#ifndef CKLEARAPPDATADECODER_H
#define CKLEARAPPDATADECODER_H

#include <iostream>
#include <cstdio>
#include <ctype.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <linux/dvb/dmx.h>
#include <errno.h>

#include <qdatetime.h>

#include "../CKlearAppConfig.h"

#include "CKlearAppDecodingHelper.h"
#include "CKlearAppDecodingTables.h"
#include "CKlearAppDescriptorParser.h"

#include "CKlearAppEITData.h" // general storage class
#include "CKlearAppSectionData.h"  // Section storage class
#include "CKlearAppDescriptorData.h"  // Descriptor storage class

#include "CKlearAppDataLayer.h" // VectorDatabase Layer

// EIT PID in transport stream
#define EIT_PID 0x012

#define SECT_BUF_SIZE (256*1024)    /* default DMX buffer size */
#define READ_BUF_SIZE (32*1024)     /* section work buffer (section is @5K) */

/* !!! get this from configuration in Klear  !!! */
#define DEMUX_DEVICE "/dev/dvb/adapter0/demux0"
#define DVR_DEVICE "/dev/dvb/adapter0/dvr0"
#define FRONTEND_DEVICE "/dev/dvb/adapter0/frontend0"

/**
Gets the read buffer and decodes the event table,
see ETSI EN-300 468

@author Marco Kraus <marco@klear.org> with many code from dvbsnoop, vlc and libdvbpsi
*/
class CKlearAppDataDecoder
{

public:
    CKlearAppDataDecoder(std::vector<CKlearAppEITData *> *storage, CKlearAppConfig *Config);
    CKlearAppDataDecoder(u_int SID);
    ~CKlearAppDataDecoder();

    void decodeBuffer( u_char *buf, int len );

private:
    void debugPrintSectionDataItem(CKlearAppSectionData *SectionData);
    void setupEPGDatabase();
    CKlearAppConfig *KlearConfig;
    void decodeSection(u_char *b, int len);
    int  decodeDescriptor(u_char *b, DTAG_SCOPE scope, CKlearAppDescriptorData *DD);
    std::vector<CKlearAppEITData *> *EITDataVector;
};

#endif
