#ifndef CKLEARAPPSTREAMREADER_H
#define CKLEARAPPSTREAMREADER_H

#include "qthread.h"

#include "../CKlearAppConfig.h"

#include "CKlearAppDataDecoder.h"
#include "CKlearAppEITData.h"

/**
Filters for PID 0x12 (EIT) on demux device, grabs data
and passes the buffer to the decoder

@author Marco Kraus <marco@klear.org> with many code from dvbsnoop, vlc and libdvbpsi
*/
class CKlearAppStreamReader : public QThread
{

public:
    CKlearAppStreamReader(std::vector<CKlearAppEITData *> *storage, CKlearAppConfig *config);
    ~CKlearAppStreamReader();

    void setRunning(bool v);
    void readContent();
    void run();

private:
   bool setUpDemux();
   void tearDownDemux();

   void readSectorLoop();
   long readBuffer();

   u_char  buf[READ_BUF_SIZE];       /* data buffer */
   int DemuxFD;
   bool running;
   CKlearAppDataDecoder *decoder;
};

#endif
